update doctor CI job
[releng.git] / jjb / opnfv / opnfv-docker.sh
1 #!/bin/bash
2 # SPDX-license-identifier: Apache-2.0
3 ##############################################################################
4 # Copyright (c) 2016 Ericsson AB and others.
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10 set -o errexit
11 set -o nounset
12 set -o pipefail
13
14
15 echo "Starting opnfv-docker for $DOCKER_REPO_NAME ..."
16 echo "--------------------------------------------------------"
17 echo
18
19
20 if [[ -n $(ps -ef|grep 'docker build'|grep -v grep) ]]; then
21     echo "There is already another build process in progress:"
22     echo $(ps -ef|grep 'docker build'|grep -v grep)
23     # Abort this job since it will colide and might mess up the current one.
24     echo "Aborting..."
25     exit 1
26 fi
27
28 # Remove previous running containers if exist
29 if [[ -n "$(docker ps -a | grep $DOCKER_REPO_NAME)" ]]; then
30     echo "Removing existing $DOCKER_REPO_NAME containers..."
31     docker ps -a | grep $DOCKER_REPO_NAME | awk '{print $1}' | xargs docker rm -f
32     t=60
33     # Wait max 60 sec for containers to be removed
34     while [[ $t -gt 0 ]] && [[ -n "$(docker ps| grep $DOCKER_REPO_NAME)" ]]; do
35         sleep 1
36         let t=t-1
37     done
38 fi
39
40
41 # Remove existing images if exist
42 if [[ -n "$(docker images | grep $DOCKER_REPO_NAME)" ]]; then
43     echo "Docker images to remove:"
44     docker images | head -1 && docker images | grep $DOCKER_REPO_NAME
45     image_tags=($(docker images | grep $DOCKER_REPO_NAME | awk '{print $2}'))
46     for tag in "${image_tags[@]}"; do
47         if [[ -n "$(docker images|grep $DOCKER_REPO_NAME|grep $tag)" ]]; then
48             echo "Removing docker image $DOCKER_REPO_NAME:$tag..."
49             docker rmi -f $DOCKER_REPO_NAME:$tag
50         fi
51     done
52 fi
53
54 # If we just want to update the latest_stable image
55 if [[ "$UPDATE_LATEST_STABLE" == "true" ]]; then
56     echo "Pulling $DOCKER_REPO_NAME:$STABLE_TAG ..."
57     docker pull $DOCKER_REPO_NAME:$STABLE_TAG
58     if [[ $? -ne 0 ]]; then
59         echo "ERROR: The image $DOCKER_REPO_NAME with tag $STABLE_TAG does not exist."
60         exit 1
61     fi
62     docker tag $DOCKER_REPO_NAME:$STABLE_TAG $DOCKER_REPO_NAME:latest_stable
63     echo "Pushing $DOCKER_REPO_NAME:latest_stable ..."
64     docker push $DOCKER_REPO_NAME:latest_stable
65     exit 0
66 fi
67
68
69 # cd to directory where Dockerfile is located
70 cd $WORKSPACE/docker
71 if [ ! -f ./Dockerfile ]; then
72     echo "ERROR: Dockerfile not found."
73     exit 1
74 fi
75
76 # Get tag version
77 branch="${GIT_BRANCH##origin/}"
78 echo "Current branch: $branch"
79
80 if [[ "$branch" == "master" ]]; then
81     DOCKER_TAG="master"
82     DOCKER_BRANCH_TAG="latest"
83 else
84     git clone https://gerrit.opnfv.org/gerrit/releng $WORKSPACE/releng
85
86     DOCKER_TAG=$($WORKSPACE/releng/utils/calculate_version.sh -t docker \
87         -n $DOCKER_REPO_NAME)
88     DOCKER_BRANCH_TAG="stable"
89
90     ret_val=$?
91     if [[ $ret_val -ne 0 ]]; then
92         echo "Error retrieving the version tag."
93         exit 1
94     fi
95 fi
96 echo "Tag version to be build and pushed: $DOCKER_TAG"
97
98
99 # Start the build
100 echo "Building docker image: $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG"
101
102 if [[ $DOCKER_REPO_NAME == *"functest"* ]]; then
103     docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG --build-arg BRANCH=$branch .
104 else
105     docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG .
106 fi
107
108 echo "Creating tag '$DOCKER_TAG'..."
109 docker tag $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG $DOCKER_REPO_NAME:$DOCKER_TAG
110
111 # list the images
112 echo "Available images are:"
113 docker images
114
115 # Push image to Dockerhub
116 if [[ "$PUSH_IMAGE" == "true" ]]; then
117     echo "Pushing $DOCKER_REPO_NAME:$DOCKER_TAG to the docker registry..."
118     echo "--------------------------------------------------------"
119     echo
120     # Push to the Dockerhub repository
121     echo "Pushing $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG ..."
122     docker push $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG
123
124     echo "Pushing $DOCKER_REPO_NAME:$DOCKER_TAG ..."
125     docker push $DOCKER_REPO_NAME:$DOCKER_TAG
126 fi